/** Unautomobile pu percorrere una certa distanza e consumare carburante
*/
public class Car  {
  /** Costruisce unautomobile con dati descrittivi e efficienza assegnati. 
      Carburante iniziale = 0
      @param anOwner nome del proprietario
      @param aRegistrationNum numero di targa
      @param anEfficiency km percorsi con un litro 					di carburante
      */
  public Car(String anOwner, String aRegistrationNum, double anEfficiency) {
    gas = 0.0;
    owner = anOwner;
    registrationNum = aRegistrationNum;
    efficiency = anEfficiency;
  }

  /** Costruisce unautomobile con dati descrittivi, efficienza e carburante 
    iniziale assegnati.
    @param anOwner nome del proprietario
    @param aRegistrationNum numero di targa
    @param anEfficiency km percorsi con un litro 					di carburante
    @param initialGas litri di carburante 						iniziale
*/
  public Car(String anOwner, String aRegistrationNum, double anEfficiency,
    double initialGas) {
    gas = initialGas;
    owner = anOwner;
    registrationNum = aRegistrationNum;
    efficiency = anEfficiency;
  }

  /** Aggiunge carburante al serbatoio.
      @param amount la quantit in litri
  */
  public void addGas(double amount) {
    gas = gas + amount;
  }

  /** Percorre una distanza consumando carburante.
     @param distance distanza in km 
  */
  public void drive(double distance) {
    // decremento il carburante presente basandomi sul consumo medio
    double consumedGas = distance / efficiency;
    gas = gas - consumedGas;
  }

  /** Ispeziona la quantit di carburante rimasta nel serbatoio
      @returns la quantit rimasta in litri
  */
  public double getGas() {
    return gas;
  }

  /** D una descrizione dellauto
      @return una stringa di descrizione
  */
  public String getDescription() {
    return "Macchina targata: " + registrationNum + "\nProprietario: " + owner
      ;
  }

  // Il nome del proprietario
  private String owner;

  // Numero di targa
  private String registrationNum;

  // Carburante attualmente presente in litri
  private double gas;

  // km percorsi in media con un litro
  private double efficiency;
}
